/*!The Treasure Box Library
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2009-present, TBOOX Open Source Group.
 *
 * @author      ruki
 * @file        strdup.c
 * @ingroup     libc
 *
 */

/* //////////////////////////////////////////////////////////////////////////////////////
 * includes
 */
#include "string.h"

/* //////////////////////////////////////////////////////////////////////////////////////
 * interfaces
 */

tb_char_t* tb_strdup(tb_char_t const* s)
{
    // check
    tb_assert_and_check_return_val(s, tb_null);

    // make
    __tb_register__ tb_size_t   n = tb_strlen(s);
    __tb_register__ tb_char_t*  p = tb_malloc_cstr(n + 1);
    tb_assert_and_check_return_val(p, tb_null);

    // copy
    tb_memcpy(p, s, n);

    // end
    p[n] = '\0';

    // ok
    return p;
}
